<?php
//*************************************************************************************
//Connaitre la vitesse du vent en temps réel grace  un anmomtre Holfui.
// V0.1
// gyvr le 10/2/2021
//**************************************************************************************

$langue = array ("web","fr");

$nom = array
(       array("speed","vitesse"),
		array("wind_gust","rafale"),

//        array("dir","direction_lettres"),
//        array("avg_dir","direction_moyenne_lettres"),
        array("gust","rafale"),
        array("max_gust","rafale_max"),
        
        array("avg_speed","vent_moy_15mn"),
        array("daily_max_speed","vent_max_24h"),
        array("max_gust","rafale_max"),
        array("temperature","temperature"),
        array("daily_avg_speed","vent_moy_24h"),
        array("daily_max_wind","vent_max_24h"),
        array("daily_max_temp","temp_max_24h"),
        array("daily_min_temp","temp_min_24h"),
        array("wind_chill","temp_ressentie"),
        array("pressure","pression"),
        array("rain","pluie"),
        array("humidity","humidite"),
        array("cloud_base","base_nuages"),
  );


function sdk_decode_VAR ($string)
{
$debut = 0; 
$fin = 1; 
$ret ="";
//echo $string; 
//echo PHP_EOL;

while ($fin !== false)
	{
		$mid   = strpos( $string," ", $debut);
		$fin   = strpos($string," ", $mid +1);
		if ( $fin !== false)
		{
			$ret .= "&" .substr ($string,$debut,$mid - $debut). "=" 
						.substr ($string,$mid+1,$fin -$mid-1);
		}
		else
		{
			$ret .= "&" .substr ($string,$debut,$mid - $debut). "=" 
						.substr ($string,$mid+1);
		}		
						
						
//echo PHP_EOL;
//echo "debut ".$debut;
//echo " mid ".$mid;
//echo " fin ".$fin;
//echo PHP_EOL; 

//echo $ret; 
//echo PHP_EOL;

	$debut = $fin +1; 
	}

//echo $ret; 
//echo PHP_EOL;

return $ret; 
}

function sdk_decode_wind_speed($string, $occurence)
{
$ret = "";

//        echo PHP_EOL;
  //      echo $string;
    //    echo PHP_EOL;
        
        $exploded   = explode('title',$string);
        $exploded   = explode('"',$exploded[$occurence]);
        
      //  echo PHP_EOL;
        //echo $exploded[0];
//        echo PHP_EOL;
  //      echo PHP_EOL;
    //    echo $exploded[1];
      //  echo PHP_EOL;
        //echo PHP_EOL;
//        echo $exploded[2];
  //      echo PHP_EOL;

        $ret = substr($exploded[1],0,-2);

    //    echo PHP_EOL;
      //  echo $ret;
        //echo PHP_EOL;

                
return $ret;
}


function sdk_remove_char ($string)
{
$caracteres = array (
" " ,  //space
"\r",   //cr
"\n", //newline 
"\t" //tab= 
);

    $string = str_replace($caracteres,"", $string);

    return $string;    
}

function sdk_valeur($string)
{
//    echo PHP_EOL;
//    echo "sdk valeur";
//    echo PHP_EOL;

    $debut = strpos($string, ">");
    $fin =   strpos($string, "<");
	
	$valeur = substr ( $string , $debut + 1 , $fin - $debut -1);
    
    $valeur = sdk_remove_char($valeur);

//    echo "debut " .$debut ." fin ". $fin . " valeur " . $valeur;
    

    return $valeur; 
}
    
function sdk_decode_vent($string, $head)
{
//  echo "sdk_decode " ;
//    echo PHP_EOL;
//    echo "; my string " . $string; 
//    echo PHP_EOL;
$sub_str = 0;

$ret ="";

$ret ="";
$pos = strpos($string, "j_");
if ($pos !== false)
    {
    $exploded   = explode('id="j_',$string);
        foreach ($exploded as $substring )
        { 
  //      echo " substring # ". $sub_str;
  //      $sub_str =  $sub_str +1;
  //  echo PHP_EOL;
  //      echo $substring;
        //echo PHP_EOL;
        foreach ($head as $key) 
        {

        
        $pos = strpos($substring, $key[0]);
          
        // Utilisez l'oprateur === pour tester la valeur de retour exacte
        if ($pos === false)
            {
           
            }
        else
            {
            if ($pos == 0)
                {
                $param_value = sdk_valeur($substring);
                if ($param_value!="")
                    {
                    $ret .= "<" .$key[0] . ">";
                    $ret .= $param_value;
                    $ret .= "</" . $key[0] .">";
                    $ret .= "\n";
                    }

                if ($key[0] == "gust")
                    {
                        $ret .= "<wind_dir>";
                        $ret .=sdk_decode_wind_speed($substring,2);
                        $ret .= "</wind_dir>";
                        $ret .= "\n";
                    }
                if ($key[0] == "max_gust")
                    {
                        $ret .= "<gust_dir>";
                        $ret .=sdk_decode_wind_speed($substring, 1);
                        $ret .= "</gust_dir>";
                        $ret .= "\n";
                    }
    

                }
            }
        }
    }
}
    return $ret;
}

$station = getArg('station');
$units= getArg('units');

//echo $station;
//echo PHP_EOL;
//echo $units;
//echo PHP_EOL;

$holfuy_ID = "station=1303";
$url = "https://widget.holfuy.com/?&mode=detailed";

$url .= sdk_decode_VAR ($units); 
//echo $url;
//echo PHP_EOL;
$url .= sdk_decode_VAR($station); 

//echo $url;
//echo PHP_EOL;
//die();



$reponse = httpQuery($url,$action='GET'); 

$exploded   = explode('act_data_header',$reponse);

$xml  = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>";
$xml .= "\n";
$xml .="<holfuy>";
$xml .= "\n";

//$n = 0;

    foreach ($exploded as $input_string) 
    {
//        echo PHP_EOL;
//        echo $n;
  //      echo "   ";
    //    echo $input_string;
      //  $n = $n+1;

        $xml .= sdk_decode_vent($input_string, $nom);
    }
$xml .="</holfuy>";
//    $xml = sdk_remove_char($xml);
    echo $xml;
?>


